INCLUDE(ExternalProject)

SET(prefix ${PROJECT_BINARY_DIR}/third_party/CLBlast)
SET(CLBlast_location ${prefix}/${CMAKE_STATIC_LIBRARY_PREFIX}/libclblast${CMAKE_STATIC_LIBRARY_SUFFIX})
SET(byproducts ${clBLAS_location})

ExternalProject_Add(
    CLBlast-ext
    GIT_REPOSITORY https://github.com/cnugteren/CLBlast.git
    GIT_TAG 0.10.0
    PREFIX "${prefix}"
    INSTALL_DIR "${prefix}"
    UPDATE_COMMAND ""
    CONFIGURE_COMMAND ${CMAKE_COMMAND} -Wno-dev "-G${CMAKE_GENERATOR}" <SOURCE_DIR>/
    -DCMAKE_CXX_COMPILER:FILEPATH=${CMAKE_CXX_COMPILER}
    "-DCMAKE_CXX_FLAGS:STRING=${CMAKE_CXX_FLAGS} -w -fPIC"
    -DCMAKE_C_COMPILER:FILEPATH=${CMAKE_C_COMPILER}
    "-DCMAKE_C_FLAGS:STRING=${CMAKE_C_FLAGS} -w -fPIC"
    -DCMAKE_BUILD_TYPE:STRING=${CMAKE_BUILD_TYPE}
    -DCMAKE_INSTALL_PREFIX:PATH=<INSTALL_DIR>
    -DBUILD_SHARED_LIBS:BOOL=OFF
    -DSAMPLES:BOOL=OFF
    -DTUNERS:BOOL=OFF
    -DCLIENTS:BOOL=OFF
    -DTESTS:BOOL=OFF
    -DNETLIB:BOOL=OFF
    ${byproducts}
    )

ExternalProject_Get_Property(CLBlast-ext install_dir)
ADD_LIBRARY(CLBlast IMPORTED STATIC)
SET_TARGET_PROPERTIES(CLBlast PROPERTIES IMPORTED_LOCATION ${CLBlast_location})
ADD_DEPENDENCIES(CLBlast CLBlast-ext)
SET(CLBLAST_INCLUDE_DIRS ${install_dir}/include)
SET(CLBLAST_LIBRARIES CLBlast)
SET(CLBLAST_FOUND ON)
